const HtmlMinifier = require('html-minifier').minify,
	  minifyJS = require('./zc-minify-js.js'),
	  minifyCSS = require('./zc-minify-css.js');

module.exports = function(code, settings) {
	const MINIFY_JS = settings.minifyJS || false;
	const MINIFY_CSS = settings.minifyCSS || false;

	code = HtmlMinifier(code, {
		collapseBooleanAttributes: true,
		collapseInlineTagWhitespace: true,
		collapseWhitespace: true,
		decodeEntities: true,
		includeAutoGeneratedTags: false,
		minifyCSS: MINIFY_CSS && function(code) {
			return minifyCSS(code);
		},
		minifyJS: MINIFY_JS && function(code, inline) {
			return minifyJS(code);
		},
		removeAttributeQuotes: true,
		removeComments: true,
		removeEmptyAttributes: true,
		removeOptionalTags: true,
		removeRedundantAttributes: true,
		removeScriptTypeAttributes: true,
		removeStyleLinkTypeAttributes: true,
		removeTagWhitespace: true,
		sortAttributes: true,
		sortClassName: true,
		trimCustomFragments: true,
	});

	return code
		.replace(/<zc-space ?\/?>/g, ' ')
		.replace(/<zc-newline ?\/>/g, '\n')
		.replace(/<zc-tab ?\/>/g, '\t');
};