const UglifyJS = require('uglify-js'),
	  process = require('process');

module.exports = function(code, settings) {
	code = code.trim();
	if (!code) return code;

	if (!settings) {
		settings = {};
	}

	try {
		return UglifyJS.minify(code, {
			fromString: true,
			mangle: {
				eval: true,
			},
			compress: {
				sequences: true,
				properties: true,
				dead_code: true,
				drop_debugger: !settings.debug,
				unsafe: true,
				conditionals: true,
				comparisons: true,
				evaluate: true,
				booleans: true,
				loops: true,
				unused: true,
				hoist_funs: true,
				hoist_vars: false,
				if_return: true,
				join_vars: true,
				cascade: true,
				collapse_vars: true,
				reduce_vars: true,
				warnings: true,
				negate_iife: true,
				drop_console: !settings.debug,
				keep_fargs: true,
				keep_fnames: false,
				passes: 3,
			},
		}).code;
	} catch (e) {
		console.error(e);
		process.exit(1);
	}
};